searchData={"items":[{"type":"module","title":"Ch","doc":"Minimal HTTP ClickHouse client.","ref":"Ch.html"},{"type":"function","title":"Ch.child_spec/1","doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"Ch.html#child_spec/1"},{"type":"function","title":"Ch.query/4","doc":"Runs a query and returns the result as `{:ok, %Ch.Result{}}` or\n`{:error, Exception.t()}` if there was a database error.","ref":"Ch.html#query/4"},{"type":"function","title":"Options - Ch.query/4","doc":"* `:timeout` - Query request timeout\n  * `:settings` - Keyword list of settings\n  * `:database` - Database\n  * `:username` - Username\n  * `:password` - User password","ref":"Ch.html#query/4-options"},{"type":"function","title":"Ch.query!/4","doc":"Runs a query and returns the result or raises `Ch.Error` if\nthere was an error. See `query/4`.","ref":"Ch.html#query!/4"},{"type":"function","title":"Ch.start_link/1","doc":"Start the connection process and connect to ClickHouse.","ref":"Ch.html#start_link/1"},{"type":"function","title":"Options - Ch.start_link/1","doc":"* `:hostname` - server hostname, defaults to `\"localhost\"`\n  * `:port` - HTTP port, defualts to `8123`\n  * `:scheme` - HTTP scheme, defaults to `\"http\"`\n  * `:database` - Database, defaults to `\"default\"`\n  * `:username` - Username\n  * `:password` - User password\n  * `:settings` - Keyword list of ClickHouse settings\n  * `:timeout` - HTTP receive timeout in milliseconds\n  * `:transport_opts` - options to be given to the transport being used. See `Mint.HTTP1.connect/4` for more info","ref":"Ch.html#start_link/1-options"},{"type":"module","title":"Ch.Query","doc":"Query struct wrapping the SQL statement.","ref":"Ch.Query.html"},{"type":"type","title":"Ch.Query.t/0","doc":"","ref":"Ch.Query.html#t:t/0"},{"type":"module","title":"Ch.Result","doc":"Result struct returned from any successful query. Its fields are:\n\n  * `command` - An atom of the query command, for example: `:select`, `:insert`;\n  * `rows` - The result set. One of:\n    - a list of lists, each inner list corresponding to a\n      row, each element in the inner list corresponds to a column;\n    - raw iodata when the response is not automatically decoded, e.g. `x-clickhouse-format: CSV`\n  * `num_rows` - The number of fetched or affected rows;\n  * `headers` - The HTTP response headers","ref":"Ch.Result.html"},{"type":"type","title":"Ch.Result.t/0","doc":"","ref":"Ch.Result.html#t:t/0"},{"type":"module","title":"Ch.RowBinary","doc":"Helpers for working with ClickHouse [`RowBinary`](https://clickhouse.com/docs/en/sql-reference/formats#rowbinary) format.","ref":"Ch.RowBinary.html"},{"type":"function","title":"Ch.RowBinary.decode_rows/1","doc":"Decodes [`RowBinaryWithNamesAndTypes`](https://clickhouse.com/docs/en/sql-reference/formats#rowbinarywithnamesandtypes) into rows.\n\nExample:\n\n    iex> decode_rows(<<1, 3, \"1+1\"::bytes, 5, \"UInt8\"::bytes, 2>>)\n    [[2]]","ref":"Ch.RowBinary.html#decode_rows/1"},{"type":"function","title":"Ch.RowBinary.decode_rows/2","doc":"Decodes [`RowBinary`](https://clickhouse.com/docs/en/sql-reference/formats#rowbinary) into rows.\n\nExample:\n\n    iex> decode_rows(<<1>>, [\"UInt8\"])\n    [[1]]","ref":"Ch.RowBinary.html#decode_rows/2"},{"type":"function","title":"Ch.RowBinary.encode_row/2","doc":"Encodes a single row to [`RowBinary`](https://clickhouse.com/docs/en/sql-reference/formats#rowbinary) as iodata.\n\nExamples:\n\n    iex> encode_row([], [])\n    []\n\n    iex> encode_row([1], [\"UInt8\"])\n    [1]\n\n    iex> encode_row([3, \"hello\"], [\"UInt8\", \"String\"])\n    [3, [5 | \"hello\"]]","ref":"Ch.RowBinary.html#encode_row/2"},{"type":"function","title":"Ch.RowBinary.encode_rows/2","doc":"Encodes multiple rows to [`RowBinary`](https://clickhouse.com/docs/en/sql-reference/formats#rowbinary) as iodata.\n\nExamples:\n\n    iex> encode_rows([], [])\n    []\n\n    iex> encode_rows([[1]], [\"UInt8\"])\n    [1]\n\n    iex> encode_rows([[3, \"hello\"], [4, \"hi\"]], [\"UInt8\", \"String\"])\n    [3, [5 | \"hello\"], 4, [2 | \"hi\"]]","ref":"Ch.RowBinary.html#encode_rows/2"},{"type":"module","title":"Ch.Types","doc":"Helpers to turn ClickHouse types into Elixir terms for easier processing.","ref":"Ch.Types.html"},{"type":"function","title":"Ch.Types.array/1","doc":"Helper for `Array(T)` ClickHouse type:\n\n    iex> array(u64())\n    {:array, :u64}\n\n    iex> to_string(encode(array(u64())))\n    \"Array(UInt64)\"\n\n    iex> decode(\"Array(UInt64)\")\n    array(u64())","ref":"Ch.Types.html#array/1"},{"type":"function","title":"Ch.Types.boolean/0","doc":"Helper for `Bool` ClickHouse type:\n\n    iex> boolean()\n    :boolean\n\n    iex> encode(boolean())\n    \"Bool\"\n\n    iex> decode(\"Bool\")\n    boolean()","ref":"Ch.Types.html#boolean/0"},{"type":"function","title":"Ch.Types.date32/0","doc":"Helper for `Date32` ClickHouse type:\n\n    iex> date32()\n    :date32\n\n    iex> encode(date32())\n    \"Date32\"\n\n    iex> decode(\"Date32\")\n    date32()","ref":"Ch.Types.html#date32/0"},{"type":"function","title":"Ch.Types.date/0","doc":"Helper for `Date` ClickHouse type:\n\n    iex> date()\n    :date\n\n    iex> encode(date())\n    \"Date\"\n\n    iex> decode(\"Date\")\n    date()","ref":"Ch.Types.html#date/0"},{"type":"function","title":"Ch.Types.datetime64/1","doc":"Helper for `DateTime64(precision)` ClickHouse type:\n\n    iex> datetime64(3)\n    {:datetime64, 3}\n\n    iex> to_string(encode(datetime64(3)))\n    \"DateTime64(3)\"\n\n    iex> decode(\"DateTime64(3)\")\n    datetime64(3)","ref":"Ch.Types.html#datetime64/1"},{"type":"function","title":"Ch.Types.datetime64/2","doc":"Helper for `DateTime64(precision, timezone)` ClickHouse type:\n\n    iex> datetime64(3, \"UTC\")\n    {:datetime64, 3, \"UTC\"}\n\n    iex> to_string(encode(datetime64(3, \"UTC\")))\n    \"DateTime64(3, 'UTC')\"\n\n    iex> decode(\"DateTime64(3, 'UTC')\")\n    datetime64(3, \"UTC\")","ref":"Ch.Types.html#datetime64/2"},{"type":"function","title":"Ch.Types.datetime/0","doc":"Helper for `DateTime` ClickHouse type:\n\n    iex> datetime()\n    :datetime\n\n    iex> to_string(encode(datetime()))\n    \"DateTime\"\n\n    iex> decode(\"DateTime\")\n    datetime()","ref":"Ch.Types.html#datetime/0"},{"type":"function","title":"Ch.Types.datetime/1","doc":"Helper for `DateTime(timezone)` ClickHouse type:\n\n    iex> datetime(\"Europe/Vienna\")\n    {:datetime, \"Europe/Vienna\"}\n\n    iex> to_string(encode(datetime(\"UTC\")))\n    \"DateTime('UTC')\"\n\n    iex> decode(\"DateTime('UTC')\")\n    datetime(\"UTC\")","ref":"Ch.Types.html#datetime/1"},{"type":"function","title":"Ch.Types.decimal32/1","doc":"Helper for `Decimal32(S)` ClickHouse type:\n\n    iex> decimal32(4)\n    {:decimal32, 4}\n\n    iex> to_string(encode(decimal32(4)))\n    \"Decimal(9, 4)\"\n\n    iex> decode(\"Decimal32(4)\")\n    {:decimal32, 4}","ref":"Ch.Types.html#decimal32/1"},{"type":"function","title":"Ch.Types.decimal64/1","doc":"Helper for `Decimal64(S)` ClickHouse type:\n\n    iex> decimal64(4)\n    {:decimal64, 4}\n\n    iex> to_string(encode(decimal64(4)))\n    \"Decimal(18, 4)\"\n\n    iex> decode(\"Decimal64(4)\")\n    {:decimal64, 4}","ref":"Ch.Types.html#decimal64/1"},{"type":"function","title":"Ch.Types.decimal128/1","doc":"Helper for `Decimal128(S)` ClickHouse type:\n\n    iex> decimal128(4)\n    {:decimal128, 4}\n\n    iex> to_string(encode(decimal128(4)))\n    \"Decimal(38, 4)\"\n\n    iex> decode(\"Decimal128(4)\")\n    {:decimal128, 4}","ref":"Ch.Types.html#decimal128/1"},{"type":"function","title":"Ch.Types.decimal256/1","doc":"Helper for `Decimal256(S)` ClickHouse type:\n\n    iex> decimal256(4)\n    {:decimal256, 4}\n\n    iex> to_string(encode(decimal256(4)))\n    \"Decimal(76, 4)\"\n\n    iex> decode(\"Decimal256(4)\")\n    {:decimal256, 4}","ref":"Ch.Types.html#decimal256/1"},{"type":"function","title":"Ch.Types.decimal/2","doc":"Helper for `Decimal(P, S)` ClickHouse type:\n\n    iex> decimal(18, 4)\n    {:decimal, 18, 4}\n\n    iex> to_string(encode(decimal(18, 4)))\n    \"Decimal(18, 4)\"\n\n    iex> decode(\"Decimal(18, 4)\")\n    decimal(18, 4)","ref":"Ch.Types.html#decimal/2"},{"type":"function","title":"Ch.Types.decode/1","doc":"Decodes a ClickHouse type into an intermediary Elixir term.\n\n    iex> decode(\"String\")\n    :string\n\n    iex> decode(\"Array(String)\")\n    {:array, :string}\n\n    iex> decode(\"Enum8('hello' = 1, 'world' = 2)\")\n    {:enum8, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> decode(\"Nullable(Decimal(18, 4))\")\n    {:nullable, {:decimal, 18, 4}}","ref":"Ch.Types.html#decode/1"},{"type":"function","title":"Ch.Types.encode/1","doc":"Encodes a type from Elixir atom / tuple to proper ClickHouse name.\n\n    iex> encode(:string)\n    \"String\"\n\n    iex> IO.iodata_to_binary(encode({:nullable, :i8}))\n    \"Nullable(Int8)\"","ref":"Ch.Types.html#encode/1"},{"type":"function","title":"Ch.Types.enum8/1","doc":"Helper for `Enum8` ClickHouse type:\n\n    iex> enum8([{\"hello\", 1}, {\"world\", 2}])\n    {:enum8, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> to_string(encode(enum8([{\"hello\", 1}, {\"world\", 2}])))\n    \"Enum8('hello' = 1, 'world' = 2)\"\n\n    iex> decode(\"Enum8('hello' = 1, 'world' = 2)\")\n    enum8([{\"hello\", 1}, {\"world\", 2}])","ref":"Ch.Types.html#enum8/1"},{"type":"function","title":"Ch.Types.enum16/1","doc":"Helper for `Enum16` ClickHouse type:\n\n    iex> enum16([{\"hello\", 1}, {\"world\", 2}])\n    {:enum16, [{\"hello\", 1}, {\"world\", 2}]}\n\n    iex> to_string(encode(enum16([{\"hello\", 1}, {\"world\", 2}])))\n    \"Enum16('hello' = 1, 'world' = 2)\"\n\n    iex> decode(\"Enum16('hello' = 1, 'world' = 2)\")\n    enum16([{\"hello\", 1}, {\"world\", 2}])","ref":"Ch.Types.html#enum16/1"},{"type":"function","title":"Ch.Types.f32/0","doc":"Helper for `Float32` ClickHouse type:\n\n    iex> f32()\n    :f32\n\n    iex> encode(f32())\n    \"Float32\"\n\n    iex> decode(\"Float32\")\n    f32()","ref":"Ch.Types.html#f32/0"},{"type":"function","title":"Ch.Types.f64/0","doc":"Helper for `Float64` ClickHouse type:\n\n    iex> f64()\n    :f64\n\n    iex> encode(f64())\n    \"Float64\"\n\n    iex> decode(\"Float64\")\n    f64()","ref":"Ch.Types.html#f64/0"},{"type":"function","title":"Ch.Types.fixed_string/1","doc":"Helper for `FixedString(n)` ClickHouse type:\n\n    iex> fixed_string(3)\n    {:fixed_string, 3}\n\n    iex> to_string(encode(fixed_string(16)))\n    \"FixedString(16)\"\n\n    iex> decode(\"FixedString(16)\")\n    fixed_string(16)","ref":"Ch.Types.html#fixed_string/1"},{"type":"function","title":"Ch.Types.i8/0","doc":"Helper for `Int8` ClickHouse type:\n\n    iex> i8()\n    :i8\n\n    iex> encode(i8())\n    \"Int8\"\n\n    iex> decode(\"Int8\")\n    i8()","ref":"Ch.Types.html#i8/0"},{"type":"function","title":"Ch.Types.i16/0","doc":"Helper for `Int16` ClickHouse type:\n\n    iex> i16()\n    :i16\n\n    iex> encode(i16())\n    \"Int16\"\n\n    iex> decode(\"Int16\")\n    i16()","ref":"Ch.Types.html#i16/0"},{"type":"function","title":"Ch.Types.i32/0","doc":"Helper for `Int32` ClickHouse type:\n\n    iex> i32()\n    :i32\n\n    iex> encode(i32())\n    \"Int32\"\n\n    iex> decode(\"Int32\")\n    i32()","ref":"Ch.Types.html#i32/0"},{"type":"function","title":"Ch.Types.i64/0","doc":"Helper for `Int64` ClickHouse type:\n\n    iex> i64()\n    :i64\n\n    iex> encode(i64())\n    \"Int64\"\n\n    iex> decode(\"Int64\")\n    i64()","ref":"Ch.Types.html#i64/0"},{"type":"function","title":"Ch.Types.i128/0","doc":"Helper for `Int128` ClickHouse type:\n\n    iex> i128()\n    :i128\n\n    iex> encode(i128())\n    \"Int128\"\n\n    iex> decode(\"Int128\")\n    i128()","ref":"Ch.Types.html#i128/0"},{"type":"function","title":"Ch.Types.i256/0","doc":"Helper for `Int256` ClickHouse type:\n\n    iex> i256()\n    :i256\n\n    iex> encode(i256())\n    \"Int256\"\n\n    iex> decode(\"Int256\")\n    i256()","ref":"Ch.Types.html#i256/0"},{"type":"function","title":"Ch.Types.ipv4/0","doc":"Helper for `IPv4` ClickHouse type:\n\n    iex> ipv4()\n    :ipv4\n\n    iex> encode(ipv4())\n    \"IPv4\"\n\n    iex> decode(\"IPv4\")\n    ipv4()","ref":"Ch.Types.html#ipv4/0"},{"type":"function","title":"Ch.Types.ipv6/0","doc":"Helper for `IPv6` ClickHouse type:\n\n    iex> ipv6()\n    :ipv6\n\n    iex> encode(ipv6())\n    \"IPv6\"\n\n    iex> decode(\"IPv6\")\n    ipv6()","ref":"Ch.Types.html#ipv6/0"},{"type":"function","title":"Ch.Types.low_cardinality/1","doc":"Helper for `LowCardinality(T)` ClickHouse type:\n\n    iex> low_cardinality(string())\n    {:low_cardinality, :string}\n\n    iex> to_string(encode(low_cardinality(string())))\n    \"LowCardinality(String)\"\n\n    iex> decode(\"LowCardinality(String)\")\n    low_cardinality(string())","ref":"Ch.Types.html#low_cardinality/1"},{"type":"function","title":"Ch.Types.map/2","doc":"Helper for `Map(K, V)` ClickHouse type:\n\n    iex> map(string(), array(string()))\n    {:map, :string, {:array, :string}}\n\n    iex> to_string(encode(map(string(), array(string()))))\n    \"Map(String, Array(String))\"\n\n    iex> decode(\"Map(String, Array(String))\")\n    map(string(), array(string()))","ref":"Ch.Types.html#map/2"},{"type":"function","title":"Ch.Types.multipolygon/0","doc":"Helper for `MultiPolygon` ClickHouse type:\n\n    iex> multipolygon()\n    :multipolygon\n\n    iex> encode(multipolygon())\n    \"MultiPolygon\"\n\n    iex> decode(\"MultiPolygon\")\n    multipolygon()","ref":"Ch.Types.html#multipolygon/0"},{"type":"function","title":"Ch.Types.nothing/0","doc":"Helper for `Nothing` ClickHouse type:\n\n    iex> nothing()\n    :nothing\n\n    iex> encode(nothing())\n    \"Nothing\"\n\n    iex> decode(\"Nothing\")\n    nothing()","ref":"Ch.Types.html#nothing/0"},{"type":"function","title":"Ch.Types.nullable/1","doc":"Helper for `Nullable(T)` ClickHouse type:\n\n    iex> nullable(array(boolean()))\n    {:nullable, {:array, :boolean}}\n\n    iex> to_string(encode(nullable(array(boolean()))))\n    \"Nullable(Array(Bool))\"\n\n    iex> decode(\"Nullable(Array(Bool))\")\n    nullable(array(boolean()))","ref":"Ch.Types.html#nullable/1"},{"type":"function","title":"Ch.Types.point/0","doc":"Helper for `Point` ClickHouse type:\n\n    iex> point()\n    :point\n\n    iex> encode(point())\n    \"Point\"\n\n    iex> decode(\"Point\")\n    point()","ref":"Ch.Types.html#point/0"},{"type":"function","title":"Ch.Types.polygon/0","doc":"Helper for `Polygon` ClickHouse type:\n\n    iex> polygon()\n    :polygon\n\n    iex> encode(polygon())\n    \"Polygon\"\n\n    iex> decode(\"Polygon\")\n    polygon()","ref":"Ch.Types.html#polygon/0"},{"type":"function","title":"Ch.Types.ring/0","doc":"Helper for `Ring` ClickHouse type:\n\n    iex> ring()\n    :ring\n\n    iex> encode(ring())\n    \"Ring\"\n\n    iex> decode(\"Ring\")\n    ring()","ref":"Ch.Types.html#ring/0"},{"type":"function","title":"Ch.Types.simple_aggregate_function/2","doc":"Helper for `SimpleAggregateFunction(name, type)` ClickHouse type:\n\n    iex> simple_aggregate_function(\"any\", u8())\n    {:simple_aggregate_function, \"any\", :u8}\n\n    iex> to_string(encode(simple_aggregate_function(\"any\", u8())))\n    \"SimpleAggregateFunction(any, UInt8)\"\n\n    iex> decode(\"SimpleAggregateFunction(any, UInt8)\")\n    simple_aggregate_function(\"any\", u8())","ref":"Ch.Types.html#simple_aggregate_function/2"},{"type":"function","title":"Ch.Types.string/0","doc":"Helper for `String` ClickHouse type:\n\n    iex> string()\n    :string\n\n    iex> encode(string())\n    \"String\"\n\n    iex> decode(\"String\")\n    string()","ref":"Ch.Types.html#string/0"},{"type":"function","title":"Ch.Types.tuple/1","doc":"Helper for `Tuple(T1, T2, ...)` ClickHouse type:\n\n    iex> tuple([u64(), array(string())])\n    {:tuple, [:u64, {:array, :string}]}\n\n    iex> to_string(encode(tuple([u64(), array(string())])))\n    \"Tuple(UInt64, Array(String))\"\n\n    iex> decode(\"Tuple(UInt64, Array(String))\")\n    tuple([u64(), array(string())])","ref":"Ch.Types.html#tuple/1"},{"type":"function","title":"Ch.Types.u8/0","doc":"Helper for `UInt8` ClickHouse type:\n\n    iex> u8()\n    :u8\n\n    iex> encode(u8())\n    \"UInt8\"\n\n    iex> decode(\"UInt8\")\n    u8()","ref":"Ch.Types.html#u8/0"},{"type":"function","title":"Ch.Types.u16/0","doc":"Helper for `UInt16` ClickHouse type:\n\n    iex> u16()\n    :u16\n\n    iex> encode(u16())\n    \"UInt16\"\n\n    iex> decode(\"UInt16\")\n    u16()","ref":"Ch.Types.html#u16/0"},{"type":"function","title":"Ch.Types.u32/0","doc":"Helper for `UInt32` ClickHouse type:\n\n    iex> u32()\n    :u32\n\n    iex> encode(u32())\n    \"UInt32\"\n\n    iex> decode(\"UInt32\")\n    u32()","ref":"Ch.Types.html#u32/0"},{"type":"function","title":"Ch.Types.u64/0","doc":"Helper for `UInt64` ClickHouse type:\n\n    iex> u64()\n    :u64\n\n    iex> encode(u64())\n    \"UInt64\"\n\n    iex> decode(\"UInt64\")\n    u64()","ref":"Ch.Types.html#u64/0"},{"type":"function","title":"Ch.Types.u128/0","doc":"Helper for `UInt128` ClickHouse type:\n\n    iex> u128()\n    :u128\n\n    iex> encode(u128())\n    \"UInt128\"\n\n    iex> decode(\"UInt128\")\n    u128()","ref":"Ch.Types.html#u128/0"},{"type":"function","title":"Ch.Types.u256/0","doc":"Helper for `UInt256` ClickHouse type:\n\n    iex> u256()\n    :u256\n\n    iex> encode(u256())\n    \"UInt256\"\n\n    iex> decode(\"UInt256\")\n    u256()","ref":"Ch.Types.html#u256/0"},{"type":"function","title":"Ch.Types.uuid/0","doc":"Helper for `UUID` ClickHouse type:\n\n    iex> uuid()\n    :uuid\n\n    iex> encode(uuid())\n    \"UUID\"\n\n    iex> decode(\"UUID\")\n    uuid()","ref":"Ch.Types.html#uuid/0"},{"type":"exception","title":"Ch.Error","doc":"Error struct wrapping ClickHouse error responses.","ref":"Ch.Error.html"},{"type":"type","title":"Ch.Error.t/0","doc":"","ref":"Ch.Error.html#t:t/0"},{"type":"extras","title":"Ch","doc":"# Ch\n\n[![Hex Package](https://img.shields.io/hexpm/v/ch.svg)](https://hex.pm/packages/ch)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/ch)\n\nMinimal HTTP ClickHouse client for Elixir.\n\nUsed in [Ecto ClickHouse adapter.](https://github.com/plausible/chto)\n\n#","ref":"readme.html"},{"type":"extras","title":"Key features - Ch","doc":"- RowBinary\n- Native query parameters\n- Per query settings\n- Minimal API\n\nYour ideas are welcome [here.](https://github.com/plausible/ch/issues/82)","ref":"readme.html#key-features"},{"type":"extras","title":"Installation - Ch","doc":"```elixir\ndefp deps do\n  [\n    {:ch, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Ch","doc":"##","ref":"readme.html#usage"},{"type":"extras","title":"Start [DBConnection](https://github.com/elixir-ecto/db_connection) pool - Ch","doc":"```elixir\ndefaults = [\n  scheme: \"http\",\n  hostname: \"localhost\",\n  port: 8123,\n  database: \"default\",\n  settings: [],\n  pool_size: 1,\n  timeout: :timer.seconds(15)\n]\n\n{:ok, pid} = Ch.start_link(defaults)\n```\n\n##","ref":"readme.html#start-dbconnection-https-github-com-elixir-ecto-db_connection-pool"},{"type":"extras","title":"Select rows - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT 3\")\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT {$0:UInt8}\", [3])\n\n{:ok, %Ch.Result{rows: [[0], [1], [2]]}} =\n  Ch.query(pid, \"SELECT * FROM system.numbers LIMIT {limit:UInt8}\", %{\"limit\" => 3})\n```\n\nNote on datetime encoding in query parameters:\n\n- `%NaiveDateTime{}` is encoded as text to make it assume the column's or ClickHouse server's timezone\n- `%DateTime{time_zone: \"Etc/UTC\"}` is encoded as unix timestamp and is treated as UTC timestamp by ClickHouse\n- encoding non UTC `%DateTime{}` raises `ArgumentError`\n\n##","ref":"readme.html#select-rows"},{"type":"extras","title":"Insert rows - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES (0), (1)\")\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES ({$0:UInt8}), ({$1:UInt32})\", [0, 1])\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) VALUES ({a:UInt16}), ({b:UInt64})\", %{\"a\" => 0, \"b\" => 1})\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) SELECT number FROM system.numbers LIMIT {limit:UInt8}\", %{\"limit\" => 2})\n```\n\n##","ref":"readme.html#insert-rows"},{"type":"extras","title":"Insert rows as [RowBinary](https://clickhouse.com/docs/en/interfaces/formats#rowbinary) (efficient) - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\ntypes = [\"UInt64\"]\n# or\ntypes = [Ch.Types.u64()]\n# or\ntypes = [:u64]\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) FORMAT RowBinary\", [[0], [1]], types: types)\n```\n\nNote that RowBinary format encoding requires `:types` option to be provided.\n\nSimilarly, you can use [`RowBinaryWithNamesAndTypes`](https://clickhouse.com/docs/en/interfaces/formats#rowbinarywithnamesandtypes) which would additionally do something like a type check.\n\n```elixir\nsql = \"INSERT INTO ch_demo FORMAT RowBinaryWithNamesAndTypes\"\nopts = [names: [\"id\"], types: [\"UInt64\"]]\nrows = [[0], [1]]\n\n%Ch.Result{num_rows: 2} = Ch.query!(pid, sql, rows, opts)\n```\n\n##","ref":"readme.html#insert-rows-as-rowbinary-https-clickhouse-com-docs-en-interfaces-formats-rowbinary-efficient"},{"type":"extras","title":"Insert rows in custom [format](https://clickhouse.com/docs/en/interfaces/formats) - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\ncsv = [0, 1] |> Enum.map(&to_string/1) |> Enum.intersperse(?\\n)\n\n%Ch.Result{num_rows: 2} =\n  Ch.query!(pid, \"INSERT INTO ch_demo(id) FORMAT CSV\", csv, encode: false)\n```\n\n##","ref":"readme.html#insert-rows-in-custom-format-https-clickhouse-com-docs-en-interfaces-formats"},{"type":"extras","title":"Insert rows as chunked RowBinary stream - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null\")\n\nstream = Stream.repeatedly(fn -> [:rand.uniform(100)] end)\nchunked = Stream.chunk_every(stream, 100)\nencoded = Stream.map(chunked, fn chunk -> Ch.RowBinary.encode_rows(chunk, _types = [\"UInt64\"]) end)\nten_encoded_chunks = Stream.take(encoded, 10)\n\n%Ch.Result{num_rows: 1000} =\n  Ch.query(pid, \"INSERT INTO ch_demo(id) FORMAT RowBinary\", ten_encoded_chunks, encode: false)\n```\n\nThis query makes a [`transfer-encoding: chunked`](https://en.wikipedia.org/wiki/Chunked_transfer_encoding) HTTP request while unfolding the stream resulting in lower memory usage.\n\n##","ref":"readme.html#insert-rows-as-chunked-rowbinary-stream"},{"type":"extras","title":"Query with custom [settings](https://clickhouse.com/docs/en/operations/settings/settings) - Ch","doc":"```elixir\n{:ok, pid} = Ch.start_link()\n\nsettings = [async_insert: 1]\n\n%Ch.Result{rows: [[\"async_insert\", \"Bool\", \"0\"]]} =\n  Ch.query!(pid, \"SHOW SETTINGS LIKE 'async_insert'\")\n\n%Ch.Result{rows: [[\"async_insert\", \"Bool\", \"1\"]]} =\n  Ch.query!(pid, \"SHOW SETTINGS LIKE 'async_insert'\", [], settings: settings)\n```","ref":"readme.html#query-with-custom-settings-https-clickhouse-com-docs-en-operations-settings-settings"},{"type":"extras","title":"Caveats - Ch","doc":"##","ref":"readme.html#caveats"},{"type":"extras","title":"NULL in RowBinary - Ch","doc":"It's the same as in [`ch-go`](https://clickhouse.com/docs/en/integrations/go#nullable)\n\n> At insert time, Nil can be passed for both the normal and Nullable version of a column. For the former, the default value for the type will be persisted, e.g., an empty string for string. For the nullable version, a NULL value will be stored in ClickHouse.\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"\"\"\nCREATE TABLE ch_nulls (\n  a UInt8 NULL,\n  b UInt8 DEFAULT 10,\n  c UInt8 NOT NULL\n) ENGINE Memory\n\"\"\")\n\ntypes = [\"Nullable(UInt8)\", \"UInt8\", \"UInt8\"]\ninserted_rows = [[nil, nil, nil]]\nselected_rows = [[nil, 0, 0]]\n\n%Ch.Result{num_rows: 1} =\n  Ch.query!(pid, \"INSERT INTO ch_nulls(a, b, c) FORMAT RowBinary\", inserted_rows, types: types)\n\n%Ch.Result{rows: ^selected_rows} =\n  Ch.query!(pid, \"SELECT * FROM ch_nulls\")\n```\n\nNote that in this example `DEFAULT 10` is ignored and `0` (the default value for `UInt8`) is persisted instead.\n\nHowever, [`input()`](https://clickhouse.com/docs/en/sql-reference/table-functions/input) can be used as a workaround:\n\n```elixir\nsql = \"\"\"\nINSERT INTO ch_nulls\n  SELECT * FROM input('a Nullable(UInt8), b Nullable(UInt8), c UInt8')\n  FORMAT RowBinary\\\n\"\"\"\n\nCh.query!(pid, sql, inserted_rows, types: [\"Nullable(UInt8)\", \"Nullable(UInt8)\", \"UInt8\"])\n\n%Ch.Result{rows: [[0], [10]]} =\n  Ch.query!(pid, \"SELECT b FROM ch_nulls ORDER BY b\")\n```\n\n##","ref":"readme.html#null-in-rowbinary"},{"type":"extras","title":"UTF-8 in RowBinary - Ch","doc":"When decoding [`String`](https://clickhouse.com/docs/en/sql-reference/data-types/string) columns non UTF-8 characters are replaced with `�` (U+FFFD). This behaviour is similar to [`toValidUTF8`](https://clickhouse.com/docs/en/sql-reference/functions/string-functions#tovalidutf8) and [JSON format.](https://clickhouse.com/docs/en/interfaces/formats#json)\n\n```elixir\n{:ok, pid} = Ch.start_link()\n\nCh.query!(pid, \"CREATE TABLE ch_utf8(str String) ENGINE Memory\")\n\nbin = \"\\x61\\xF0\\x80\\x80\\x80b\"\nutf8 = \"a�b\"\n\n%Ch.Result{num_rows: 1} =\n  Ch.query!(pid, \"INSERT INTO ch_utf8(str) FORMAT RowBinary\", [[bin]], types: [\"String\"])\n\n%Ch.Result{rows: [[^utf8]]} =\n  Ch.query!(pid, \"SELECT * FROM ch_utf8\")\n\n%Ch.Result{rows: %{\"data\" => [[^utf8]]}} =\n  pid |> Ch.query!(\"SELECT * FROM ch_utf8 FORMAT JSONCompact\") |> Map.update!(:rows, &Jason.decode!/1)\n```\n\nTo get raw binary from `String` columns use `:binary` type that skips UTF-8 checks.\n\n```elixir\n%Ch.Result{rows: [[^bin]]} =\n  Ch.query!(pid, \"SELECT * FROM ch_utf8\", [], types: [:binary])\n```\n\n##","ref":"readme.html#utf-8-in-rowbinary"},{"type":"extras","title":"Timezones in RowBinary - Ch","doc":"Decoding non-UTC datetimes like `DateTime('Asia/Taipei')` requires a [timezone database.](https://hexdocs.pm/elixir/DateTime.html#module-time-zone-database)\n\n```elixir\nMix.install([:ch, :tz])\n\n:ok = Calendar.put_time_zone_database(Tz.TimeZoneDatabase)\n\n{:ok, pid} = Ch.start_link()\n\n%Ch.Result{rows: [[~N[2023-04-25 17:45:09]]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime)\")\n\n%Ch.Result{rows: [[~U[2023-04-25 17:45:11Z]]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime('UTC'))\")\n\n%Ch.Result{rows: [[%DateTime{time_zone: \"Asia/Taipei\"} = taipei]]} =\n  Ch.query!(pid, \"SELECT CAST(now() as DateTime('Asia/Taipei'))\")\n\n\"2023-04-26 01:45:12+08:00 CST Asia/Taipei\" = to_string(taipei)\n```\n\nEncoding non-UTC datetimes raises an `ArgumentError`\n\n```elixir\nCh.query!(pid, \"CREATE TABLE ch_datetimes(datetime DateTime) ENGINE Null\")\n\nnaive = NaiveDateTime.utc_now()\nutc = DateTime.utc_now()\ntaipei = DateTime.shift_zone!(utc, \"Asia/Taipei\")\n\n# ** (ArgumentError) non-UTC timezones are not supported for encoding: 2023-04-26 01:49:43.044569+08:00 CST Asia/Taipei\nCh.query!(pid, \"INSERT INTO ch_datetimes(datetime) FORMAT RowBinary\", [[naive], [utc], [taipei]], types: [\"DateTime\"])\n```","ref":"readme.html#timezones-in-rowbinary"},{"type":"extras","title":"Benchmarks - Ch","doc":"INSERT  1 million rows  (original)  \n\n  \n$ MIX_ENV=bench mix run bench/insert.exs\n\nThis benchmark is based on https://github.com/ClickHouse/clickhouse-go#benchmark\n\nOperating System: macOS\nCPU Information: Apple M1\nNumber of Available Cores: 8\nAvailable memory: 8 GB\nElixir 1.14.4\nErlang 25.3\n\nBenchmark suite executing with the following configuration:\nwarmup: 2 s\ntime: 5 s\nmemory time: 0 ns\nreduction time: 0 ns\nparallel: 1\ninputs: 1_000_000 rows\nEstimated total run time: 28 s\n\nBenchmarking encode with input 1_000_000 rows ...\nBenchmarking encode stream with input 1_000_000 rows ...\nBenchmarking insert with input 1_000_000 rows ...\nBenchmarking insert stream with input 1_000_000 rows ...\n\n###","ref":"readme.html#benchmarks"},{"type":"extras","title":"With input 1_000_000 rows ##### - Ch","doc":"Name                    ips        average  deviation         median         99th %\nencode stream          1.63      612.96 ms    ±11.30%      583.03 ms      773.01 ms\ninsert stream          1.22      819.82 ms     ±9.41%      798.94 ms      973.45 ms\nencode                 1.09      915.75 ms    ±44.13%      750.98 ms     1637.02 ms\ninsert                 0.73     1373.84 ms    ±31.01%     1331.86 ms     1915.76 ms\n\nComparison: \nencode stream          1.63\ninsert stream          1.22 - 1.34x slower +206.87 ms\nencode                 1.09 - 1.49x slower +302.79 ms\ninsert                 0.73 - 2.24x slower +760.88 ms \n \n\n \n\n \n  SELECT  500, 500 thousand, and 500 million rows  (original)  \n\n  \n$ MIX_ENV=bench mix run bench/stream.exs\n\nThis benchmark is based on https://github.com/ClickHouse/ch-bench\n\nOperating System: macOS\nCPU Information: Apple M1\nNumber of Available Cores: 8\nAvailable memory: 8 GB\nElixir 1.14.4\nErlang 25.3\n\nBenchmark suite executing with the following configuration:\nwarmup: 2 s\ntime: 5 s\nmemory time: 0 ns\nreduction time: 0 ns\nparallel: 1\ninputs: 500 rows, 500_000 rows, 500_000_000 rows\nEstimated total run time: 1.05 min\n\nBenchmarking stream with decode with input 500 rows ...\nBenchmarking stream with decode with input 500_000 rows ...\nBenchmarking stream with decode with input 500_000_000 rows ...\nBenchmarking stream with manual decode with input 500 rows ...\nBenchmarking stream with manual decode with input 500_000 rows ...\nBenchmarking stream with manual decode with input 500_000_000 rows ...\nBenchmarking stream without decode with input 500 rows ...\nBenchmarking stream without decode with input 500_000 rows ...\nBenchmarking stream without decode with input 500_000_000 rows ...\n\n###","ref":"readme.html#with-input-1_000_000-rows"},{"type":"extras","title":"With input 500 rows ##### - Ch","doc":"Name                                ips        average  deviation         median         99th %\nstream with decode               4.69 K      213.34 μs    ±12.49%      211.38 μs      290.94 μs\nstream with manual decode        4.69 K      213.43 μs    ±17.40%      210.96 μs      298.75 μs\nstream without decode            4.65 K      215.08 μs    ±10.79%      213.79 μs      284.66 μs\n\nComparison:\nstream with decode               4.69 K\nstream with manual decode        4.69 K - 1.00x slower +0.0838 μs\nstream without decode            4.65 K - 1.01x slower +1.74 μs\n\n###","ref":"readme.html#with-input-500-rows"},{"type":"extras","title":"With input 500_000 rows ##### - Ch","doc":"Name                                ips        average  deviation         median         99th %\nstream without decode            234.58        4.26 ms    ±13.99%        4.04 ms        5.95 ms\nstream with manual decode         64.26       15.56 ms     ±8.36%       15.86 ms       17.97 ms\nstream with decode                41.03       24.37 ms     ±6.27%       24.39 ms       26.60 ms\n\nComparison:\nstream without decode            234.58\nstream with manual decode         64.26 - 3.65x slower +11.30 ms\nstream with decode                41.03 - 5.72x slower +20.11 ms\n\n###","ref":"readme.html#with-input-500_000-rows"},{"type":"extras","title":"With input 500_000_000 rows ##### - Ch","doc":"Name                                ips        average  deviation         median         99th %\nstream without decode              0.32         3.17 s     ±0.20%         3.17 s         3.17 s\nstream with manual decode        0.0891        11.23 s     ±0.00%        11.23 s        11.23 s\nstream with decode               0.0462        21.66 s     ±0.00%        21.66 s        21.66 s\n\nComparison:\nstream without decode              0.32\nstream with manual decode        0.0891 - 3.55x slower +8.06 s\nstream with decode               0.0462 - 6.84x slower +18.50 s \n \n\n \n\n[CI Results](https://github.com/plausible/ch/actions/workflows/bench.yml) (click the latest workflow run and scroll down to \"Artifacts\")","ref":"readme.html#with-input-500_000_000-rows"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"- use `ch-#{version}` as user-agent https://github.com/plausible/ch/pull/154\n- fix query string escaping for `\\t`, `\\\\`, and `\\n` https://github.com/plausible/ch/pull/155","ref":"changelog.html#unreleased"},{"type":"extras","title":"0.2.3 (2024-01-29) - Changelog","doc":"- fix socket leak on failed handshake https://github.com/plausible/ch/pull/153","ref":"changelog.html#0-2-3-2024-01-29"},{"type":"extras","title":"0.2.2 (2023-12-23) - Changelog","doc":"- fix query encoding for datetimes with zeroed microseconds `~U[****-**-** **:**:**.000000]` https://github.com/plausible/ch/pull/138","ref":"changelog.html#0-2-2-2023-12-23"},{"type":"extras","title":"0.2.1 (2023-08-22) - Changelog","doc":"- fix array casts with `Ch` subtype https://github.com/plausible/ch/pull/118","ref":"changelog.html#0-2-1-2023-08-22"},{"type":"extras","title":"0.2.0 (2023-07-28) - Changelog","doc":"- move loading and dumping from `Ch` type to the adapter https://github.com/plausible/ch/pull/112","ref":"changelog.html#0-2-0-2023-07-28"},{"type":"extras","title":"0.1.14 (2023-05-24) - Changelog","doc":"- simplify types, again...","ref":"changelog.html#0-1-14-2023-05-24"},{"type":"extras","title":"0.1.13 (2023-05-24) - Changelog","doc":"- refactor types in `Ch.RowBinary` https://github.com/plausible/ch/pull/88","ref":"changelog.html#0-1-13-2023-05-24"},{"type":"extras","title":"0.1.12 (2023-05-24) - Changelog","doc":"- replace `{:raw, data}` with `encode: false` option, add `:decode` option https://github.com/plausible/ch/pull/42","ref":"changelog.html#0-1-12-2023-05-24"},{"type":"extras","title":"0.1.11 (2023-05-19) - Changelog","doc":"- improve Enum error message invalid values during encoding: https://github.com/plausible/ch/pull/85\n- fix `\\t` and `\\n` in query params https://github.com/plausible/ch/pull/86","ref":"changelog.html#0-1-11-2023-05-19"},{"type":"extras","title":"0.1.10 (2023-05-05) - Changelog","doc":"- support `:raw` option in `Ch` type https://github.com/plausible/ch/pull/84","ref":"changelog.html#0-1-10-2023-05-05"},{"type":"extras","title":"0.1.9 (2023-05-02) - Changelog","doc":"- relax deps versions","ref":"changelog.html#0-1-9-2023-05-02"},{"type":"extras","title":"0.1.8 (2023-05-01) - Changelog","doc":"- fix varint encoding","ref":"changelog.html#0-1-8-2023-05-01"},{"type":"extras","title":"0.1.7 (2023-04-24) - Changelog","doc":"- support RowBinaryWithNamesAndTypes","ref":"changelog.html#0-1-7-2023-04-24"},{"type":"extras","title":"0.1.6 (2023-04-24) - Changelog","doc":"- add Map(K,V) support in Ch Ecto type","ref":"changelog.html#0-1-6-2023-04-24"},{"type":"extras","title":"0.1.5 (2023-04-23) - Changelog","doc":"- fix query param encoding like Array(Date)\n- add more types support in Ch Ecto type: tuples, ipv4, ipv6, geo","ref":"changelog.html#0-1-5-2023-04-23"},{"type":"extras","title":"0.1.4 (2023-04-23) - Changelog","doc":"- actually support negative `Enum` values","ref":"changelog.html#0-1-4-2023-04-23"},{"type":"extras","title":"0.1.3 (2023-04-23) - Changelog","doc":"- support negative `Enum` values, fix `Enum16` encoding","ref":"changelog.html#0-1-3-2023-04-23"},{"type":"extras","title":"0.1.2 (2023-04-23) - Changelog","doc":"- support `Enum8` and `Enum16` encoding","ref":"changelog.html#0-1-2-2023-04-23"},{"type":"extras","title":"0.1.1 (2023-04-23) - Changelog","doc":"- cleanup published docs","ref":"changelog.html#0-1-1-2023-04-23"}],"content_type":"text/markdown"}